import networkx as nx
def floyd_warshall(G: nx.DiGraph):
    """A brute-force dynamically programmed algorithm to find the shortest distances between any pair of nodes
    It uses transitive closure, and  is suitable for directed graphs. """
    V = G.number_of_nodes()

    D = [[9999 for j in range(V)] for i in range(V)]
    for i in range(V):
        D[i][i] = 0
    for (u,v,w) in G.edges(data="weight"):
        D[u][v] = w

    for k in range(V):
        for i in range(V):
            for j in range(V):
                if (D[i][k] + D[k][j] < D[i][j]):
                    D[i][j] = D[i][k] + D[k][j]
    
    return D